package pl.edu.amu.wmi.socialaggregator.activity

import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.LinearLayoutManager
import io.reactivex.Observable
import kotlinx.android.synthetic.main.activity_post_history.*
import kotlinx.android.synthetic.main.content_post_history.*
import pl.edu.amu.wmi.socialaggregator.R
import pl.edu.amu.wmi.socialaggregator.utils.SocialPlatformsManager
import pl.edu.amu.wmi.socialaggregator.viewholders.PostDetailsRecycler
import androidx.recyclerview.widget.DividerItemDecoration



class PostHistoryActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_post_history)
        setSupportActionBar(toolbar)

        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        postHistoryRecycler.apply {
            layoutManager = LinearLayoutManager(this@PostHistoryActivity)
            adapter = PostDetailsRecycler(
                Observable.fromIterable(SocialPlatformsManager.getLoggedIn(this@PostHistoryActivity))
                    .flatMap {
                        it.getPosts(this@PostHistoryActivity)
                            .toObservable()
                    })
            addItemDecoration(
                DividerItemDecoration(
                    context,
                    (layoutManager as LinearLayoutManager).orientation
                ))
        }
    }

}
